structure Num
   0 : Num
   succ : Num -> Num

structure List
   empty : List
   add   : Num,List -> List

function plus : Num,Num -> Num
  plus(0, y) = y
  plus(succ(x), y) = succ(plus(x, y))
  
function times : Num,Num -> Num
  times(0, y) = 0
  times(succ(x), y) = plus(y, times(x, y))
  
function exp : Num,Num -> Num
  exp(x, 0) = succ(0)
  exp(x, succ(y)) = times(x, exp(x, y))
  
function pred : Num -> Num
  pred(0) = 0
  pred(succ(x)) = x

function minus : Num,Num -> Num 
  minus(x,0) = x
  minus(x,succ(y)) = minus(pred(x),y)

function ge : Num,Num -> bool
  ge(x,0) = true
  ge(0,succ(y))= false
  ge(succ(x),succ(y)) = ge(x,y)

function even : Num -> bool
  even(0) = true
  even(succ(0))=false
  even(succ(succ(x))) = even(x)

function length : List -> Num
  length(empty) = 0
  length(add(X,XS)) = succ( length(XS))

function append : List, List -> List
  append(empty, XS) = XS
  append(add(X,XS),YS) = add(X, append(XS,YS))

function rev : List -> List
  rev(empty) = empty
  rev(add(X,XS)) = append(rev(XS), add(X,empty))

function qrev : List,List -> List
  qrev(empty, YS) = YS
  qrev(add(X,XS),YS) = qrev(XS, add(X,YS))