package memquery;

import java.io.*;
import java.net.*;
import java.util.*;

public class Server {
	public static final int port = 40000;
	ServerThread serverThread = null;

	public void start() {
		if (serverThread != null) {return;}
		System.out.println("memquery server started...");
		serverThread = new ServerThread();
		serverThread.setIsRunning(true);
		serverThread.start();
	}

	public void end() {
		serverThread.setIsRunning(false);
		serverThread=null;
	}
}

class ServerThread extends Thread {
	int readTimeout = 2000;
	int packetSize = 1000;
	boolean isRunning = false;
	DatagramSocket sock = null;
	BufferedReader in = null;

	public void setIsRunning(boolean b) {
		isRunning = b;
	}

	public void run() {
		Runtime rt = java.lang.Runtime.getRuntime();
		try {
			sock = new DatagramSocket(Server.port);
			sock.setSoTimeout(readTimeout);
		} 
		catch (Exception e) {
			System.err.println(e);
			isRunning=false;
		}

		while (isRunning) {
			try {
				byte[] buff = new byte[packetSize];
				DatagramPacket packet = new DatagramPacket(buff, buff.length);
				sock.receive(packet);

				String data = new String(packet.getData());
				data = data.trim();

				InetAddress addr = packet.getAddress();
				int port = packet.getPort();
				rt.gc();
				String outStr = data + "\t" + (rt.totalMemory() - rt.freeMemory());
				buff = outStr.getBytes();

				packet = new DatagramPacket(buff, buff.length, addr, port);
				sock.send(packet);
			} catch (IOException e) {
				System.err.println(e);
			}
		}
	}
}
