aspect Common {
	pointcut lockCallers() : contains(Logger.lock() || Logger.unlock()) 
		&& !within(Logger || LockTraceMatch || MemQueryServer || memquery.*);

	pointcut lockCallersOld() : (
		execution(* org.w3c.jigedit.filters.DeletedEntry.makeEntry(..)  ) ||
		execution(* org.w3c.jigedit.filters.GrepPutFilter.ingoingFilter(..)  ) ||
		execution(* org.w3c.jigedit.filters.PutedEntry.makeEntry(..)  ) ||
		execution(* org.w3c.jigedit.filters.PutFilter.ingoingFilter(..)  ) ||
		execution(* org.w3c.jigedit.filters.PutFilter.outgoingFilter(..)  ) ||
		execution(* org.w3c.jigedit.filters.PutFilter.resolvePutListResource(..)  ) ||
		execution(* org.w3c.jigedit.filters.PutListResource.lookupDelEntry(..)  ) ||
		execution(* org.w3c.jigedit.filters.PutListResource.lookupEntry(..)  ) ||
		execution(* org.w3c.jigedit.filters.SimpleGrepFilter.ingoingFilter(..)  ) ||
		execution(* org.w3c.jigedit.filters.TidyPutFilter.ingoingFilter(..)  ) ||
		execution(* org.w3c.jigedit.frames.CvsFileFrame.getResourceDirectory(..)  ) ||
		execution(* org.w3c.jigedit.jigcvs.CvsEntryResource.getCvsManager(..)  ) ||
		execution(* org.w3c.jigedit.jigcvs.CvsEntryResource.getCvsURL(..)  ) ||
		execution(* org.w3c.jigedit.jigcvs.CvsEntryResource.getHtmlGenerator(..)  ) ||
		execution(* org.w3c.jigedit.jigcvs.CvsEntryResource.RevisionFrame.updateHeaders(..)  ) ||
		execution(* org.w3c.jigedit.jigcvs.CvsFrame.get(..)  ) ||
		execution(* org.w3c.jigedit.jigcvs.CvsFrame.getCvsManager(..)  ) ||
		execution(* org.w3c.jigedit.jigcvs.CvsFrame.handle(..)  ) ||
		execution(* org.w3c.jigedit.jigcvs.CvsFrame.isIndexed(..)  ) ||
		execution(* org.w3c.jigedit.tools.ToolsListerFrame.getDirectoryListing(..)  ) ||
		execution(* org.w3c.jigedit.tools.ToolsListerFrame.getResourceLine(..)  ) ||
		execution(* org.w3c.jigedit.tools.ToolsListerFrame.handle(..)  ) ||
		execution(* org.w3c.jigedit.tools.ToolsListerFrame.registerResource(..)  ) ||
		execution(* org.w3c.jigedit.webdav.frames.CvsDAVDirectoryFrame.lookupDirectory(..)  ) ||
		execution(* org.w3c.jigedit.webdav.frames.CvsDAVFileFrame.getResourceDirectory(..)  ) ||
		execution(* org.w3c.jigsaw.acl.AclRealm.acquireRealm(..)  ) ||
		execution(* org.w3c.jigsaw.admin.BrokerFrame.lookup(..)  ) ||
		execution(* org.w3c.jigsaw.admin.BrokerFrame.remoteDeleteResource(..)  ) ||
		execution(* org.w3c.jigsaw.admin.BrokerFrame.remoteLoadResource(..)  ) ||
		execution(* org.w3c.jigsaw.admin.BrokerFrame.remoteRegisterFrame(..)  ) ||
		execution(* org.w3c.jigsaw.admin.BrokerFrame.remoteRegisterResource(..)  ) ||
		execution(* org.w3c.jigsaw.admin.BrokerFrame.remoteReindexResource(..)  ) ||
		execution(* org.w3c.jigsaw.admin.BrokerFrame.remoteSetValues(..)  ) ||
		execution(* org.w3c.jigsaw.admin.BrokerFrame.remoteUnregisterFrame(..)  ) ||
		execution(* org.w3c.jigsaw.auth.DigestAuthFilter.authenticate(..)  ) ||
		execution(* org.w3c.jigsaw.auth.DigestAuthFilter.lookupUser(..)  ) ||
		execution(* org.w3c.jigsaw.auth.GenericAuthFilter.acquireRealm(..)  ) ||
		execution(* org.w3c.jigsaw.auth.GenericAuthFilter.authenticate(..)  ) ||
		execution(* org.w3c.jigsaw.auth.GenericAuthFilter.checkBasicAuth(..)  ) ||
		execution(* org.w3c.jigsaw.auth.GenericAuthFilter.lookupUser(..)  ) ||
		execution(* org.w3c.jigsaw.frames.HTTPFrame.browse(..)  ) ||
		execution(* org.w3c.jigsaw.frames.HTTPFrame.deleteMe(..)  ) ||
		execution(* org.w3c.jigsaw.frames.HTTPFrame.lookupDirectory(..)  ) ||
		execution(* org.w3c.jigsaw.frames.LatestChildRedirectFrame.getOtherResource(..)  ) ||
		execution(* org.w3c.jigsaw.frames.VirtualHostFrame.lookupOther(..)  ) ||
		execution(* org.w3c.jigsaw.http.httpd.changeRoot(..)  ) ||
		execution(* org.w3c.jigsaw.http.httpd.perform(..)  ) ||
		execution(* org.w3c.jigsaw.http.httpd.startCheckpoint(..)  ) ||
		execution(* org.w3c.jigsaw.indexer.ContentTypeIndexer.createFileResource(..)  ) ||
		execution(* org.w3c.jigsaw.indexer.ContentTypeIndexer.loadContentType(..)  ) ||
		execution(* org.w3c.jigsaw.resources.DirectoryResource.updateNegotiableResource(..)  ) ||
		execution(* org.w3c.jigsaw.resources.PassDirectory.setValue(..)  ) ||
		execution(* org.w3c.jigsaw.resources.PasswordEditorFrame.changePassword(..)  ) ||
		execution(* org.w3c.jigsaw.servlet.JigsawHttpServletRequest.getRequestDispatcher(..)  ) ||
		execution(* org.w3c.jigsaw.servlet.JigsawHttpServletRequest.getServletPath(..)  ) ||
		execution(* org.w3c.jigsaw.servlet.JigsawRequestDispatcher.getRequestDispatcher(..)  ) ||
		execution(* org.w3c.jigsaw.servlet.JigsawServletContext.getAttribute(..)  ) ||
		execution(* org.w3c.jigsaw.servlet.JigsawServletContext.getContext(..)  ) ||
		execution(* org.w3c.jigsaw.servlet.JigsawServletContext.getFilePath(..)  ) ||
		execution(* org.w3c.jigsaw.servlet.JigsawServletContext.getLocalRoot(..)  ) ||
		execution(* org.w3c.jigsaw.servlet.JigsawServletContext.getRealPath(..)  ) ||
		execution(* org.w3c.jigsaw.servlet.JigsawServletContext.getServer(..)  ) ||
		execution(* org.w3c.jigsaw.servlet.JigsawServletContext.getServerInfo(..)  ) ||
		execution(* org.w3c.jigsaw.servlet.JigsawServletContext.getServlet(..)  ) ||
		execution(* org.w3c.jigsaw.servlet.JigsawServletContext.getServletNames(..)  ) ||
		execution(* org.w3c.jigsaw.servlet.JigsawServletContext.getServlets(..)  ) ||
		execution(org.w3c.jigsaw.servlet.JigsawServletContext.new(..)  ) ||
		execution(* org.w3c.jigsaw.servlet.ServletDirectoryFrame.getServlet(..)  ) ||
		execution(* org.w3c.jigsaw.servlet.ServletDirectoryFrame.isServletLoaded(..)  ) ||
		execution(* org.w3c.jigsaw.servlet.ServletIndexer.createFileResource(..)  ) ||
		execution(* org.w3c.jigsaw.servlet.ServletPropertiesReader.getServletDirectoryReference(..)  ) ||
		execution(* org.w3c.jigsaw.servlet.ServletPropertiesReader.initializeServlet(..)  ) ||
		execution(* org.w3c.jigsaw.servlet.ServletPropertiesReader.preload(..)  ) ||
		execution(* org.w3c.jigsaw.servlet.ServletPropertiesReader.getServletDirectory(..)  ) ||
		execution(* org.w3c.jigsaw.ssi.servlets.ServletCommand.execute(..)  ) ||
		execution(* org.w3c.jigsaw.webdav.DAVFrame.copyCollection(..)  ) ||
		execution(* org.w3c.jigsaw.webdav.DAVFrame.getChildResponses(..)  ) ||
		execution(* org.w3c.jigsaw.webdav.DAVFrame.internalCopyCollection(..)  ) ||
		execution(* org.w3c.jigsaw.webdav.DAVFrame.lookupDirectory(..)  ) ||
		execution(* org.w3c.jigsaw.webdav.DAVFrame.unlock(..)  ) ||
		execution(* org.w3c.jigsaw.zip.ZipDirectoryResource.index(..)  ) ||
		execution(* org.w3c.jigsaw.zip.ZipFrame.computeContainerListing(..)  ) ||
		execution(* org.w3c.tools.resources.event.AttributeChangedEvent.toString(..)  ) ||
		execution(* org.w3c.tools.resources.event.Dispatcher.run(..)  ) ||
		execution(* org.w3c.tools.resources.event.StructureChangedEvent.toString(..)  ) ||
		execution(* org.w3c.tools.resources.indexer.GhostResourceIndexer.createResource(..)  ) ||
		execution(* org.w3c.tools.resources.indexer.SimpleResourceIndexer.createDirectoryResource(..)  ) ||
		execution(* org.w3c.tools.resources.indexer.SimpleResourceIndexer.createFileResource(..)  ) ||
		execution(* org.w3c.tools.resources.indexer.SimpleResourceIndexer.createResource(..)  ) ||
		execution(* org.w3c.tools.resources.indexer.SimpleResourceIndexer.createVirtualResource(..)  ) ||
		execution(* org.w3c.tools.resources.indexer.SimpleResourceIndexer.getIndexedName(..)  ) ||
		execution(* org.w3c.tools.resources.indexer.SimpleResourceIndexer.getTemplateFor(..)  ) ||
		execution(* org.w3c.tools.resources.indexer.SimpleResourceIndexer.loadDirectory(..)  ) ||
		execution(* org.w3c.tools.resources.indexer.SimpleResourceIndexer.loadExtension(..)  ) ||
		execution(* org.w3c.tools.resources.indexer.SimpleResourceIndexer.mergeDefaultAttributes(..)  ) ||
		execution(* org.w3c.tools.resources.indexer.SimpleResourceIndexer.mergeFrameAttributes(..)  ) ||
		execution(* org.w3c.tools.resources.store.NewStoreEntry.loadResource(..)  ) ||
		execution(* org.w3c.tools.resources.store.StoreEntry.loadResource(..)  ) ||
		execution(* org.w3c.tools.resources.ContainerResource.internalLookup(..)  ) ||
		execution(* org.w3c.tools.resources.ContainerResource.replace(..)  ) ||
		execution(* org.w3c.tools.resources.DirectoryResource.createDirectoryResource(..)  ) ||
		execution(* org.w3c.tools.resources.DirectoryResource.getIndexedName(..)  ) ||
		execution(* org.w3c.tools.resources.DirectoryResource.index(..)  ) ||
		execution(* org.w3c.tools.resources.DirectoryResource.initialize(..)  ) ||
		execution(* org.w3c.tools.resources.DirectoryResource.reindex(..)  ) ||
		execution(* org.w3c.tools.resources.FileResource.getFile(..)  ) ||
		execution(* org.w3c.tools.resources.FileResource.verify(..)  ) ||
		execution(* org.w3c.tools.resources.FramedResource.FramedReference.lock(..)  ) ||
		execution(* org.w3c.tools.resources.FramedResource.FramedReference.unsafeLock(..)  ) ||
		execution(* org.w3c.tools.resources.PassDirectory.setValue(..)  ) ||
		execution(* org.w3c.tools.resources.Resource.setValue(..)  ) || 
		execution(org.w3c.tools.resources.ResourceContext.new(..)  ) ||

		execution(* org.w3c.tools.resources.ContainerResource+.delete(..)  ) ||
		execution(* org.w3c.tools.resources.ContainerResource+.lookup(..)  ) ||
		execution(* org.w3c.tools.resources.Resource+.getSpaceEntry(..)  ) 
		//The following pointcuts cause a java.lang.VerifyError if they are 
		//uncommented. Note that ContainerResource is extended by 
		//ExternalContainer, Resource by DirectoryResource and ContainerResource
		//and that the pointcuts specify method executions of methods that 
		//are overriden
		//Note (13 Feb 2006): Is now fixed by Ondrej's cflowdepth fix
		//execution(* org.w3c.tools.resources.ContainerResource.delete(..)  ) ||
		//execution(* org.w3c.tools.resources.ContainerResource.lookup(..)  ) ||
		//execution(* org.w3c.tools.resources.Resource.getSpaceEntry(..)  ) 
		//execution(* org.w3c.tools.resources.ExternalContainer.delete(..)  ) ||
		//execution(* org.w3c.jigsaw.resources.DirectoryResource.lookup(..)  ) ||
		//execution(* org.w3c.tools.resources.ContainerResource.getSpaceEntry(..)  ) ||
		)
		&& 
		!within(Logger || LockTraceMatch || MemQueryServer || memquery.*);
}
