import org.w3c.tools.resources.ResourceReference;

aspect ThisLockTraceMatch {

	private static boolean debug;
	private void debPrint(String s) {
		System.out.println(s);
	}

	//everything except that in the instrumentation
	pointcut anyfunc() : Common.lockCallers();

	pointcut lock(org.w3c.tools.resources.ResourceReference r) :
		Logger.lock() && target(r);

	pointcut unlock(org.w3c.tools.resources.ResourceReference r) :
		Logger.unlock() && target(r);

	perthread tracematch(Object o,ResourceReference r, int i) {

		sym beforefunc before : anyfunc() && cflowdepth(i, anyfunc()) && this(o);
		sym afterfunc after : anyfunc() && cflowdepth(i, anyfunc()) && this(o);
		sym lock after : lock(r) && cflowbelowdepth(i, anyfunc());
		sym unlock after : unlock(r) && cflowbelowdepth(i, anyfunc());

		beforefunc lock afterfunc {
			try {
				throw new Exception("Unmatched lock");
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
}
