package benchmarks.hashset;

import java.util.*;

public aspect RealHashSetWithLet {
    
  /**
  * This version is better in a way that it checks if the modification really changed the hash code
  * of the collection in question. Also it works for arbitrary objects, not just collections.
  * BUT it uses let().
  */
 tracematch(HashSet s, Object o, int hashCode) {
     
     sym add before : call(* Collection.add(Object)) && target(s) && args(o) && let(hashCode, o.hashCode());
     sym remove before : call(* Collection.remove(Object)) && target(s) && args(o);
     sym contains before: call(* Collection.contains(..)) && target(s) && args(o);

     add contains {

         if(hashCode!=o.hashCode()) {    
             System.out.println("HashCode changed for Object "+o+" while being in a HashSet.");
         } 

     }
 }
 
    
}


class RealTest {
    
    public static void main(String[] args) {
        Set s = new HashSet();        
        Collection c = new ArrayList();
        
        s.add(c);
        s.remove(c);
        System.out.println("allowed modification");
        c.add("allowed modification");
        System.out.println(s.contains(c));
        c.clear();
        
        s.add(c);
        System.out.println("this should trigger an error");
        c.add("this should trigger an error");
        System.out.println(s.contains(c));
    }
    
}