package benchmarks.lor;

import java.util.concurrent.locks.ReentrantLock;

public class Worker implements Runnable {

    /**
     * 
     */
    private static final int TIME = 200;
    private final ReentrantLock l1, l2;
    private final double prob;
    
    /**
     * @param l1
     * @param l2
     */
    public Worker(ReentrantLock l1, ReentrantLock l2, double prob) {
        super();
        //assertions lead to trouble with "Coffi"
        //assert prob <=1 && prob >= 0;
        this.l1 = l1;
        this.l2 = l2;
        this.prob = prob;
    }

    /**
     * {@inheritDoc}
     */
    public void run() {
        
        //final Thread t = Thread.currentThread(); 
        
        while(true) {
        
            if(Math.random()>prob) {
                l1.lock();
                sleep();
                l2.lock();
                sleep();
            } else {
                l2.lock();
                sleep();
                l1.lock();
                sleep();
            }
            if(Math.random()>prob) {
                l1.unlock();
                sleep();
                l2.unlock();
                sleep();
            } else {
                l2.unlock();
                sleep();
                l1.unlock();
                sleep();
            }
            
        }
        
        
    }
    
    /**
     * 
     */
    private void sleep() {
        try {
            Thread.sleep(3000 + Math.round(Math.random() * TIME));
        } catch (InterruptedException e) {
        }
    }

}
